## functracer 0.19+0m5

=== doc/Makefile ===

DOC = functracer_internals
FIGS = functracer_architecture.eps

all: $(DOC).pdf $(DOC).html

$(DOC).pdf: $(DOC).txt
	TMPDIR=$(shell mktemp -d) && \
	asciidoc -d article -b docbook -o $$TMPDIR/file.xml $< && \
	cp $(FIGS) $$TMPDIR/ && \
	dblatex --pdf -o $@ $$TMPDIR/file.xml; \
	#(cd $$TMPDIR && docbook2pdf -o . file.xml) && \
	#mv $$TMPDIR/file.pdf $@; \
	rm -rf $$TMPDIR

$(DOC).html: $(DOC).txt
	asciidoc -o $@ $<

clean:
	rm -f $(DOC).pdf $(DOC).html

## functracer 0.9.2

=== debian/changelog ===
functracer (0.9.2) unstable; urgency=low

  * Fix some lintian warnings, copyrights and README.
  * Change option letter for help messagei (us -h).
  * Create man page automatically.
  * Change addresses to have same width.
  * Replace TODO/XXX comments for FIXME.
  * Avoid reporting internal/recursive calls.
  * Generate only one .trace file per process.
  * Trace pthread_mutex_lock/pthread_mutex_unlock functions.

 -- Bruna Moreira <bruna.moreira@indt.org.br>  Fri, 12 Sep 2008 14:40:23 -0400

functracer (0.9.1) unstable; urgency=low

  * Fix segfault when non-write permission is received.
  * Fix race condition on get_process_state().
  * Move ft_wait*() functions to right place.

 -- Bruna Moreira <bruna.moreira@indt.org.br>  Fri, 08 Aug 2008 07:46:27 -0400

functracer (0.9) unstable; urgency=low

  * Attach all processes/threads when using -p option.
  * Avoid enable or disable breakpoints more than once.
  * Share breakpoints between parent and children.
  * Fix verification for repeated return addresses.
  * Add support for multithreaded programs.

 -- Bruna Moreira <bruna.moreira@indt.org.br>  Fri, 01 Aug 2008 14:38:12 -0400

functracer (0.8) unstable; urgency=low

  * Add a header to trace file.
  * Reorganize report functions.
  * Add option to enable address resolution on functracer.
  * Add option to enable backtraces for free().
  * Fix compilation warnings.
  * Remove "name" variable from debug message.
  * Added error check on unw_get_proc_name().
  * Update documentation (README, manpage).
  * Decrement IP value to get correct line on post-processing.

 -- Ricardo Guimaraes <ricardo.guimaraes@indt.org.br>  Fri, 04 Jul 2008 15:47:18 -0400

functracer (0.7) unstable; urgency=low

  * Name resolution (unw_get_proc_name) removed. 

 -- Bruna Moreira <bruna.moreira@indt.org.br>  Fri, 20 Jun 2008 13:27:32 -0400

functracer (0.6) unstable; urgency=low

  * Enable realloc() tracing.
  * Change ptrace for using PTRACE_CONT.
  * Remove remaining handling to SIGUSR2.
  * Fix segfault when permission denied is received.
  * Fix segfault when more than one process is tracked.
  * Enable libunwind cache (unw_set_caching_policy).
  * Suppress "free(NULL)" calls from trace output.

 -- Bruna Moreira <bruna.moreira@indt.org.br>  Fri, 13 Jun 2008 14:49:01 -0400

functracer (0.5) unstable; urgency=low

  * Add debug package creation.
  * Add the __libc_ prefix for tracing functions.
  * Move rp_copy_maps() to rp_finish().
  * Simplify reporting functions.
  * Support for enabling debug during compilation.
  * Fix dump control regression (just toggle the tracing on/off).
  * Update documentation.

 -- Bruna Moreira <bruna.moreira@indt.org.br>  Mon, 02 Jun 2008 13:23:24 -0400

functracer (0.4) unstable; urgency=low

  * Initial release.

 -- Bruno de Oliveira Abinader <bruno.abinader@openbossa.org>  Tue, 06 May 2008 16:01:34 -0400

=== debian/control ===
Source: functracer
Section: devel
Priority: optional
Maintainer: Bruna Moreira <bruna.moreira@indt.org.br>
Build-Depends: debhelper (>= 5), autotools-dev, help2man, binutils-dev, libunwind7-dev
Standards-Version: 3.8.0

Package: functracer
Architecture: any
Depends: ${shlibs:Depends}
Description: An Allocation Backtrace Tool
 Functracer is a debugging tool. It gets backtraces of all allocations done in
 ARM/x86 processes. It works with optimized (-O2) code, where debugging symbols
 are available either in the application  binaries themselves, or in separate
 debug files.

Package: functracer-dbg
Section: devel
Priority: extra
Architecture: any
Depends: functracer (= ${binary:Version})
Description: An Allocation Backtrace Tool - debug
 Functracer is a debugging tool. It gets backtraces of all allocations done in
 ARM/x86 processes. It works with optimized (-O2) code, where debugging symbols
 are available either in the application  binaries themselves, or in separate
 debug files.
 This package includes the debug symbols.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1


# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)
DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

CFLAGS=-Wall -O2 -g

ifneq (,$(findstring debug,$(DEB_BUILD_OPTIONS)))
	debugopts += --enable-debug
endif

config.status: configure
	dh_testdir
	# Add here commands to configure the package.
ifneq "$(wildcard /usr/share/misc/config.sub)" ""
	cp -f /usr/share/misc/config.sub config.sub
endif
ifneq "$(wildcard /usr/share/misc/config.guess)" ""
	cp -f /usr/share/misc/config.guess config.guess
endif

	./configure --host=$(DEB_HOST_GNU_TYPE) --build=$(DEB_BUILD_GNU_TYPE) --prefix=/usr $(debugopts) --mandir=\$${prefix}/share/man --infodir=\$${prefix}/share/info CFLAGS="$(CFLAGS)" LDFLAGS="-Wl,-z,defs"

build: build-stamp

build-stamp:  config.status
	dh_testdir

	# Add here commands to compile the package.
	$(MAKE)
	help2man src/functracer -N -o man/functracer.1 -i man/functracer.1.inc 

	touch $@

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp 

	# Add here commands to clean up after the build process.
	[ ! -f Makefile ] || $(MAKE) distclean
	rm -f config.sub config.guess
	rm -f man/functracer.1

	dh_clean 

install: build
	dh_testdir
	dh_testroot
	dh_clean -k 
	dh_installdirs

	# Add here commands to install the package into debian/functracer.
	$(MAKE) DESTDIR=$(CURDIR)/debian/functracer install


# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs 
	dh_installdocs
	dh_installexamples
#	dh_install
#	dh_installmenu
#	dh_installdebconf	
#	dh_installlogrotate
#	dh_installemacsen
#	dh_installpam
#	dh_installmime
#	dh_python
#	dh_installinit
#	dh_installcron
#	dh_installinfo
	dh_installman -p functracer man/functracer.1
	dh_link
	dh_strip --dbg-package=functracer
	dh_compress
	dh_fixperms
#	dh_perl
#	dh_makeshlibs
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install

## functracer 0.17+0m5

=== debian/changelog ===
functracer (0.17+0m5) unstable; urgency=low

  * This entry has been added by BIFH queue processor
    Suffix +0m5 added to package revision

 -- Kiryl Shutsemau <kiryl.shutsemau@nokia.com>  Tue, 09 Jun 2009 14:24:28 +0300

functracer (0.17) unstable; urgency=low

  * Fix segfault on attaching to non-main thread (NB#120151)
  * Update version in configure.ac (NB#120152)

 -- Kiryl Shutsemau <kiryl.shutsemau@nokia.com>  Tue, 9 Jun 2009 12:43:17 +0200

functracer (0.16) unstable; urgency=low

  * Rewrite processes and threads hangling to avoid assumptions about ptrace's
    messages order. It should work correctly on Fremantle now.

 -- Kiryl Shutsemau <kiryl.shutsemau@nokia.com>  Tue, 7 May 2009 10:53:05 +0200

functracer (0.15.1maemo1) unstable; urgency=low

  * Fix a crash occurring when process does not yet have parent
    information available. Fixes: NB#99869
  * Applied a patch to fix realpath() portability problems by using
    readlink() instead. Fixes: NB#100765

 -- Eero Tamminen <eero.tamminen@nokia.com>  Tue, 17 Feb 2009 15:59:11 +0200

functracer (0.15.1) unstable; urgency=low

  * Small fixes in documentation: README, README.plugins, TODO.plugins and
    manpage.

 -- Bruna Moreira <bruna.moreira@indt.org.br>  Thu, 29 Jan 2009 07:53:01 -0400

functracer (0.15) unstable; urgency=low

  * Plugins cleanup.
  * Add a new event to fork in parent process.
  * Do not read symbols from the target program and dynamic linker.
  * Add new functions to file plugin.
  * Change info messages to show "process/thread".
  * Fix date shown in trace header.
  * Add new specific documentation to plugins.
  * Add a README to testsuite.

 -- Bruna Moreira <bruna.moreira@indt.org.br>  Tue, 20 Jan 2009 16:03:53 -0400

functracer (0.14) unstable; urgency=low

  * Add verbose option.
  * Avoid ptrace() errors due to missing libraries.
  * Change minimal backtrace depth to zero.
  * Organize testsuite directories.
  * Fix leaks in clone and fork tests.
  * Add new flags and fix warnings in testsuite.
  * Add support to C++ programs on testsuite.
  * Add new test to C++ programs in testsuite.
  * Add "Functracer Internals" sources.
  * Testsuite improvements.
  * Add new tests for calloc, realloc and memalign functions.
  * Add new tests for open/close operations.
  * Modify instructions for SSOL support.
  * Debian packaging fixes.
  * Move architecture specific defines out of configure.ac.
  * x86: allow inserting breakpoints in instructions with size 8.
  * Memory plugin fixes (memalign, posix_memalign).
  * solib.c: ignore symbols with no defined address.
  * Fix copyright header in testsuite files.

 -- Bruna Moreira <bruna.moreira@indt.org.br>  Mon, 19 Dec 2008 14:08:14 -0400

functracer (0.13) unstable; urgency=low

  * Add a new exec event on callback.
  * Add new data to trace file header.
  * Add support to timestamps.
  * Remove unnecessary check to lock functions.
  * Add a sequence to load plugin module.
  * Change plugin infrastructure.
  * Rename tests directory to testsuite.
  * Implement support to dejagnu test framework.
  * Remove utests directory.

 -- Bruna Moreira <bruna.moreira@indt.org.br>  Thu, 04 Dec 2008 10:11:21 -0400

functracer (0.12) unstable; urgency=low

  * Add initial support to plugins.
  * Add new option "-e" to plugin name.
  * Add in configure a new entry "--with-plugins" to prefix of plugins
    installation.
  * Add check in xptrace() function.
  * Change the backtrace header format for a more generic one.
  * Avoid overwriting trace file.
  * Simplify dump control functions.
  * Handle interrupt before a singlestep action.

 -- Bruna Moreira <bruna.moreira@indt.org.br>  Wed, 12 Nov 2008 10:58:38 -0400

functracer (0.11) unstable; urgency=low

  * Fix SSOL area creation after a exec*() on ARM.
  * Remove /proc/PID/maps copying functions.
  * Dump maps information to trace file.
  * Replace get_list_of_processes() with for_each_process().
  * Fix regression in dump control; indentation fixes.

 -- Bruna Moreira <bruna.moreira@indt.org.br>  Mon, 20 Oct 2008 14:03:13 -0400

functracer (0.10) unstable; urgency=low

  * Add prefix "__" on pthread_mutex_lock/pthread_mutex_unlock functions.
  * Fix allocation report for multithread programs.
  * Add missing *fPIC flag to libcallchain.so build.
  * Update .gitignore.
  * Remove unused declarations.
  * Fix memory leak in remove_process().
  * Simplify xptrace().
  * Change backtrace output format.
  * Add second line to header.
  * Small refactorings and a race condition fix.
  * Fix functracer interrupt (CTRL+C) handling.
  * Improve some tests.
  * Replace traditional breakpoint approach with SSOL.
  * Add support for reporting of process events.

 -- Bruna Moreira <bruna.moreira@indt.org.br>  Wed, 01 Oct 2008 11:29:36 -0400

## functracer 0.18.1+0m5

=== debian/changelog ===
functracer (0.18.1+0m5) unstable; urgency=low

  * This entry has been added by BIFH queue processor
    Suffix +0m5 added to package revision

 -- Kiryl Shutsemau <kiryl.shutsemau@nokia.com>  Mon, 19 Oct 2009 11:37:39 +0300

functracer (0.18.1) unstable; urgency=low

  * Rebuild with updated libunwind to fix executable stack. Fixes: NB#139340.

 -- Kiryl Shutsemau <kiryl.shutsemau@nokia.com>  Mon, 19 Oct 2009 11:28:30 +0300

functracer (0.18) unstable; urgency=low

  * Change license of functracer to GPL version 2 or later. Fixes: NB#142158.

 -- Kiryl Shutsemau <kiryl.shutsemau@nokia.com>  Tue, 13 Oct 2009 13:17:40 +0300

functracer (0.17.1) unstable; urgency=low

  * Rebuild with updated libunwind to fix executable stack. Fixes: NB#139340.

 -- Kiryl Shutsemau <kiryl.shutsemau@nokia.com>  Tue, 9 Jun 2009 12:43:17 +0200

## functracer 0.19+0m5

=== debian/changelog ===
functracer (0.19+0m5) unstable; urgency=low

  * This entry has been added by BIFH queue processor
    Suffix +0m5 added to package revision

 -- Kiryl Shutsemau <kiryl.shutsemau@nokia.com>  Fri, 12 Feb 2010 12:05:55 +0200

functracer (0.19) unstable; urgency=low

  * Fix SIGINT/SIGTERM signals handling. Fixes: NB#120608
  * Huge update. Fixes: NB#145945
    + fix handling of processes and threads
    + functracer module to track GObject allocations and releases
    + functracer module to track memory transfer operations
    + memory: suppress allocation failures and track valloc
    + file: track more calls and enhance output
    + functracer module to keep track on memory allocation/release
      caused by creating/joining/detaching threads
    + update documentation

 -- Kiryl Shutsemau <kiryl.shutsemau@nokia.com>  Fri, 12 Feb 2010 11:53:48 +0200

=== debian/control ===
Source: functracer
Section: devel
Priority: optional
Maintainer: Bruna Moreira <bruna.moreira@indt.org.br>
Build-Depends: debhelper (>= 5), autotools-dev, help2man, binutils-dev, libunwind7-dev
Standards-Version: 3.8.0

Package: functracer
Architecture: any
Depends: ${shlibs:Depends}
Description: A Function Backtrace Tool
 Functracer is a debugging tool. It collects backtraces, arguments and return
 value of functions specified in a plugin. It works with optimized (-O2) code,
 where debugging symbols are available either in the application binaries
 themselves, or in separate debug files.

Package: functracer-dbg
Section: devel
Priority: extra
Architecture: any
Depends: functracer (= ${binary:Version})
Description: A Function Backtrace Tool - debug
 Functracer is a debugging tool. It collects backtraces, arguments and return
 value of functions specified in a plugin. It works with optimized (-O2) code,
 where debugging symbols are available either in the application binaries
 themselves, or in separate debug files.
 This package includes the debug symbols.

=== debian/rules ===
--- 
+++ 
@@ -21,6 +21,9 @@
 	debugopts += --enable-debug
 endif
 
+configure: configure.ac
+	autoreconf -fisv
+
 config.status: configure
 	dh_testdir
 	# Add here commands to configure the package.
@@ -31,7 +34,7 @@
 	cp -f /usr/share/misc/config.guess config.guess
 endif
 
-	./configure --host=$(DEB_HOST_GNU_TYPE) --build=$(DEB_BUILD_GNU_TYPE) --prefix=/usr $(debugopts) --mandir=\$${prefix}/share/man --infodir=\$${prefix}/share/info CFLAGS="$(CFLAGS)" LDFLAGS="-Wl,-z,defs"
+	./configure --host=$(DEB_HOST_GNU_TYPE) --build=$(DEB_BUILD_GNU_TYPE) --prefix=/usr $(debugopts) --mandir=\$${prefix}/share/man --infodir=\$${prefix}/share/info CFLAGS="$(CFLAGS)"
 
 build: build-stamp
 
@@ -53,6 +56,7 @@
 	[ ! -f Makefile ] || $(MAKE) distclean
 	rm -f config.sub config.guess
 	rm -f man/functracer.1
+	find -name core | xargs -r rm
 
 	dh_clean 
 
@@ -62,8 +66,7 @@
 	dh_clean -k 
 	dh_installdirs
 
-	# Add here commands to install the package into debian/functracer.
-	$(MAKE) DESTDIR=$(CURDIR)/debian/functracer install
+	$(MAKE) DESTDIR=$(CURDIR)/debian/tmp install
 
 
 # Build architecture-independent files here.
@@ -77,7 +80,7 @@
 	dh_installchangelogs 
 	dh_installdocs
 	dh_installexamples
-#	dh_install
+	dh_install --sourcedir=debian/tmp
 #	dh_installmenu
 #	dh_installdebconf	
 #	dh_installlogrotate
